from setuptools import setup
from pathlib import Path
long_description = Path("./README.md").read_text()

setup(
  name='jft',
  version='0.0.74',
  license='MIT',
  description='Function Test Pair Toolbox',
  long_description=long_description,
  long_description_content_type="text/markdown",
  author='@JohnRForbes',
  author_email='john.robert.forbes@gmail.com',
  url='https://gitlab.com/zereiji/jft',
  packages=[
    'jft',
    'jft/bool',
    'jft/bool/or_none',
    'jft/bools',
    'jft/date',
    'jft/datetime',
    'jft/dict',
    'jft/dict/frequencies',
    'jft/dict/proposed_dismantlement',
    'jft/dict/test_durations',
    'jft/dicts',
    'jft/directories',
    'jft/directory',
    'jft/fake',
    'jft/fake/os',
    'jft/fake/subprocess',
    'jft/file',
    'jft/file/tar',
    'jft/file/pyfile',
    'jft/file/zip',
    'jft/files',
    'jft/files/pyfiles',
    'jft/function',
    'jft/int',
    'jft/int/year',
    'jft/lists',
    'jft/patch',
    'jft/pickle',
    'jft/pip',
    'jft/pip/dist_tar',
    'jft/pip/setup',
    'jft/pip/ver''sion',
    'jft/pyfiles',
    'jft/report',
    'jft/report/fail',
    'jft/schedule',
    'jft/session',
    'jft/setup',
    'jft/setup/cfg',
    'jft/setup/py',
    'jft/string',
    'jft/string/alphanumeric',
    'jft/string/append',
    'jft/string/chars',
    'jft/string/contains',
    'jft/string/contains/function',
    'jft/string/digits',
    'jft/string/family_name',
    'jft/string/filename',
    'jft/string/fn_name',
    'jft/string/given_name',
    'jft/string/hbar',
    'jft/string/header',
    'jft/string/header/python_file',
    'jft/string/header/test_table',
    'jft/string/indent',
    'jft/string/insert',
    'jft/string/json',
    'jft/string/password',
    'jft/string/refactor',
    'jft/string/remove',
    'jft/string/replace',
    'jft/string/single_line_function',
    'jft/string/spaces',
    'jft/string/token',
    'jft/strings',
    'jft/strings/contain',
    'jft/strings/pyfiles',
    'jft/subprocess',
    'jft/subprocess/completed_process',
    'jft/system',
    'jft/system/git',
    'jft/system/git/commit',
    'jft/system/git/gitignore',
    'jft/system/screen',
    'jft/test',
    'jft/text_colours',
    'jft/text_colours/bright',
    'jft/text_colours/dark',
  ],
  keywords='jft',
  install_requires=[],
)
